package org.dromara.im.service;

import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.im.domain.bo.ImFriendBo;
import org.dromara.im.domain.vo.ImFriendVo;
import java.util.Collection;
import java.util.List;

/**
 * 好友Service接口
 *
 * @author Luo.J
 * @date 2025-05-15
 */
public interface IImFriendService {

    /**
     * 查询好友
     *
     * @param id 主键
     * @return 好友
     */
    ImFriendVo queryById(Long id);

    /**
     * 分页查询好友列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 好友分页列表
     */
    TableDataInfo<ImFriendVo> queryPageList(ImFriendBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的好友列表
     *
     * @param bo 查询条件
     * @return 好友列表
     */
    List<ImFriendVo> queryList(ImFriendBo bo);

    /**
     * 新增好友
     *
     * @param bo 好友
     * @return 是否新增成功
     */
    Boolean insertByBo(ImFriendBo bo);

    /**
     * 修改好友
     *
     * @param bo 好友
     * @return 是否修改成功
     */
    Boolean updateByBo(ImFriendBo bo);

    /**
     * 校验并批量删除好友信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    void initialize(Long userId);

}
